% Esempi di due successioni derivate dalla formulazione di uno stesso
% integrale con comportamento numericamente stabile ed instabile.

disp('ESEMPIO: Stabilita degli integrali');


% Prima successione non numericamente stabile
s = zeros(100,1);
s(1) = exp(-1);   
for n = 1:length(s)-1
    s(n+1) = 1-(n+1)*s(n);
end

% Seconda successione numericamente stabile
t = zeros(100,1);
for n = length(t):-1:2
    t(n-1) = (1 - t(n))/n;
end

% Visualizzazione delle soluzioni
figure;
clf;
indvis = 1:30;
h=semilogy(indvis,abs(s(indvis)),'k-');
set(h,'LineWidth',2);
hold on;
h=semilogy(indvis,abs(t(indvis)),'m-');
set(h,'LineWidth',2);
hold off;
legend('s','t')
title('Esempio di succ. da formulazione integrale');
xlabel('Iterazione');
