function model_egg
% Esercizio di modellistica numerica
% Come cucinare un uovo

M = linspace(10,80,11);  % [g] dal piccolo uovo al grande uovo
Twtr = 100;     % [C] temperatura dell'acqua
Tyolk = 63;     % [C] temperatura di cottura

% Primo tipo di cottura
Tegg = 4;       % [C] temperatura da frigorifero
t1 = boiling_cook(M,Tegg,Tyolk,Twtr);

% Secondo tipo di cottura
Tegg = 21;      % [C] temperatura ambiente
t2 = boiling_cook(M,Tegg,Tyolk,Twtr);

figure;
h = plot(M,t1/60,'b-',M,t2/60,'r-');
set(h,'LineWidth',2);
legend('temp. frig.','temp. amb.');
xlabel('Massa [g]');
ylabel('[minuti]');
title('Tempo di cottura di un uovo');   

function t = boiling_cook(M,Tegg,Tyolk,Twtr)

% Dati interni dell'uovo
rho = 1.038;    % [g/cm^3] densita'
K = 5.4e-3;     % [W/(cm K)] conduttivita' termica
c = 3.7;        % [J/(g K)] calore specifico

t = (M.^(2/3)*c*rho^(1/3))/(K*pi^2*(4/3*pi)^(2/3))*log(0.76*(Tegg-Twtr)/(Tyolk-Twtr));
